controllers/SiteController.php
<?php

namespace app\controllers;
use yii\data\SqlDataProvider;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Puerto;
use app\models\Etapa;
use yii\data\ActiveDataProvider;
use app\models\Equipo;


class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    /*
     * Creado esta accion
     */
    
    public function actionCrud(){
        return $this->render('gestion');
    }


     public function actionConsulta1a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            
            'query'=> Ciclista::find()->joinWith('etapas',true)->distinct()->select("nombre, edad")->where("etapa.dorsal is null")
                ,
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
           return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 1",
            "enunciado"=>"Nombre y edad de los ciclistas que no han ganado etapas.",
            "sql"=>"SELECT DISTINCT ciclista.nombre, ciclista.edad FROM ciclista LEFT JOIN etapa ON ciclista.dorsal=etapa.dorsal WHERE etapa.dorsal IS NULL",
        ]);
    }
    
     public function actionConsulta1(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT COUNT(*) FROM (SELECT DISTINCT ciclista.nombre, ciclista.edad FROM ciclista LEFT JOIN etapa ON ciclista.dorsal=etapa.dorsal WHERE etapa.dorsal IS NULL) c1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT ciclista.nombre, ciclista.edad FROM ciclista LEFT JOIN etapa ON ciclista.dorsal=etapa.dorsal WHERE etapa.dorsal IS NULL" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>0,
                ],
        ]);
        
            return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 1",
            "enunciado"=>"Nombre y edad de los ciclistas que no han ganado etapas.",
            "sql"=>"SELECT DISTINCT ciclista.nombre, ciclista.edad FROM ciclista LEFT JOIN etapa ON ciclista.dorsal=etapa.dorsal WHERE etapa.dorsal IS NULL",
        ]);


     }

    
     public function actionConsulta2a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            
            'query'=> Ciclista::find()->joinWith( 'puertos',true)->distinct()->select("nombre, edad")->where("puerto.dorsal is null")
                 ,
            'pagination'=>[
                'pageSize'=>30,
                ]
        ]);
                
        // $a=Ciclista::find()->innerJoinWith( 'puertos',true,'inner join')->all();
        // var_dump($a[0]->puertos); // innerJoinWith utiliza los modelos que ya est´n relacionados 
           return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 2",
            "enunciado"=>"Nombre y edad de los ciclistas que no han ganado puertos.",
            "sql"=>"SELECT DISTINCT c.nombre, c.edad FROM puerto p INNER JOIN ciclista c ON c.dorsal=p.dorsal",
        ]);
    }
    
     public function actionConsulta2(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT COUNT(*) FROM (SELECT DISTINCT ciclista.nombre, ciclista.edad FROM ciclista LEFT JOIN puerto ON ciclista.dorsal=puerto.dorsal WHERE puerto.dorsal IS NULL) c1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT ciclista.nombre, ciclista.edad FROM ciclista LEFT JOIN puerto ON ciclista.dorsal=puerto.dorsal WHERE puerto.dorsal IS NULL" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>30,
                ],
        ]);
        
            return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nombre', 'edad'],
            "titulo"=>"Consulta 2",
            "enunciado"=>"Nombre y edad de los ciclistas que no han ganado puertos.",
            "sql"=>"SELECT DISTINCT ciclista.nombre, ciclista.edad FROM ciclista LEFT JOIN puerto ON ciclista.dorsal=puerto.dorsal WHERE puerto.dorsal IS NULL",
        ]);


     }
     
     
          public function actionConsulta3a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            
            'query'=> Ciclista::find()->joinWith( 'etapas',true)->innerJoin('equipo','equipo.nomequipo=ciclista.nomequipo')->distinct()->select("equipo.director as direc")->where("etapa.dorsal IS NULL")
                 ,
            'pagination'=>[
                'pageSize'=>10,
                ]
        ]);
                
        // $a=Ciclista::find()->innerJoinWith( 'puertos',true,'inner join')->all();
        // var_dump($a[0]->puertos); // innerJoinWith utiliza los modelos que ya est´n relacionados 
           return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['direc'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"Listar el director de los equipos que tengan ciclistas NO que hayan ganado NINGUNA etapa.",
            "sql"=>"SELECT DISTINCT equipo.director FROM equipo INNER JOIN (ciclista LEFT JOIN etapa ON ciclista.dorsal=etapa.dorsal)  ON equipo.nomequipo=ciclista.nomequipo WHERE etapa.dorsal IS NULL",
        ]);
    }
    
     public function actionConsulta3(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT COUNT(*) FROM (SELECT DISTINCT equipo.director FROM equipo INNER JOIN (ciclista LEFT JOIN etapa ON ciclista.dorsal=etapa.dorsal)  ON equipo.nomequipo=ciclista.nomequipo WHERE etapa.dorsal IS NULL) c1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT equipo.director FROM equipo INNER JOIN (ciclista LEFT JOIN etapa ON ciclista.dorsal=etapa.dorsal)  ON equipo.nomequipo=ciclista.nomequipo WHERE etapa.dorsal IS NULL" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>10,
                ],
        ]);
        
            return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['director'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"Listar el director de los equipos que tengan ciclistas NO que hayan ganado NINGUNA etapa.",
            "sql"=>"SELECT DISTINCT equipo.director FROM equipo INNER JOIN (ciclista LEFT JOIN etapa ON ciclista.dorsal=etapa.dorsal)  ON equipo.nomequipo=ciclista.nomequipo WHERE etapa.dorsal IS NULL",
        ]);


     }
    
    
    public function actionConsulta4a(){
        
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->JoinWith('llevas',true)->distinct()->select("ciclista.dorsal, nombre")->where("lleva.dorsal IS NULL")
                         ,
            'pagination'=>[
                'pageSize'=>10,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal','nombre'],
            "titulo"=>"Consulta 4",
            "enunciado"=>"Dorsal y nombre de los ciclistas que no hayan llevado algún maillot.",
            "sql"=>"SELECT DISTINCT ciclista.dorsal, ciclista.nombre FROM ciclista LEFT JOIN lleva ON ciclista.dorsal=lleva.dorsal WHERE lleva.dorsal IS NULL",
        ]);
    }
    
     public function actionConsulta4(){
            // mediante DAO
        
         $numero=Yii::$app
                ->db->createCommand("SELECT COUNT(*) FROM (SELECT DISTINCT ciclista.dorsal, ciclista.nombre FROM ciclista LEFT JOIN lleva ON ciclista.dorsal=lleva.dorsal WHERE lleva.dorsal IS NULL) c1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT DISTINCT ciclista.dorsal, ciclista.nombre FROM ciclista LEFT JOIN lleva ON ciclista.dorsal=lleva.dorsal WHERE lleva.dorsal IS NULL" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[

views/site/_listar.php
        <tr>
            <td><h3><?= $model->dorsal ?>  </h3></td>
            
        </tr>
        

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/gestion.php
<?php

use yii\helpers\Html;

echo Html::a('Ciclistas',
        ['ciclista/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Etapas',
        ['etapa/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Equipos',
        ['equipo/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Lleva',
        ['lleva/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Maillot',
        ['maillot/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Puerto',
        ['puerto/index'],
        ['class' => 'btn btn-primary btn-large']
        );



?>

views/site/index.php
<?php
use yii\bootstrap\Html;
/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>

<div class="site-index">

    <div class="jumbotron">
        <h1>consultas de seleccion 5</h1>
Application
        <p class="lead">Modulo 3 Unidad 2</p>
    </div>

    <div class="body-content">

        <div class="row">
            
             <!-- primera consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 1</h3>
                      <p>Nombre y edad de los ciclistas que no han ganado etapas.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta1a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta1'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
             
              <!-- segunda consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 2</h3>
                      <p>Nombre y edad de los ciclistas que no han ganado puertos.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta2a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta2'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- tercera consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 3</h3>
                      <p>Listar el director de los equipos que tengan ciclistas NO que hayan ganado NINGUNA etapa.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta3a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta3'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- cuarta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 4</h3>
                      <p>Dorsal y nombre de los ciclistas que no hayan llevado algún maillot.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta4a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta4'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- quinta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 5</h3>
                      <p>Dorsal y nombre de los ciclistas que NO hayan llevado algún maillot amarillo.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta5a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta5'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- sexta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 6</h3>
                      <p>Indicar el numetapa de las etapas que NO tengan puertos.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta6a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta6'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- septima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 7</h3>
                      <p>Indicar La distancia media de las etapas que no tengan puertos.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta7a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta7'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              
              <!-- octava consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 8</h3>
                      <p>Listar el número de ciclists que NO hayan ganado alguna etapa.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta8a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta8'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- novena consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 9</h3>
                      <p>Listar el dorsal de los ciclistas que hayan ganado alguna etapa que no tenga puerto.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta9a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta9'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- decima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 10</h3>
                      <p>Listar el dorsal de los ciclistas que hayan ganado únicamente etapas que no tengan puertos.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta10a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta10'],['class' => 'btn btn-default btn-large']);?>
                          <?= Html::a('ListView',['site/consulta10b'],['class' => 'btn btn-default btn-large']);?>
                          <?= Html::a('Active Record2',['site/consulta10c'],['class' => 'btn btn-primary btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
                            
              
        </div>

    </div>
</div>

views/site/listView.php
<div>
    <h1>Listar el dorsal de los ciclistas que hayan ganado únicamente etapas que no tengan puertos.</h1>
    
</div>

<?php
use yii\widgets\ListView;
?>
<table border="5">
    <thead>
        <tr>
            <th>Dorsal</th>
        </tr>
    </thead>
      <tbody>
<?php
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar',
]);
?>
  
    </tbody>
</table>

views/site/resultado.php
<?php
use yii\grid\GridView;

?>


 <div class="jumbotron">
        <h1><?= $titulo?></h1>
        <p class="lead"><?=$enunciado?></p>
            <div class="well"> 
            <?= $sql?>
            </div>
    </div>
    
    
    <?= GridView::widget([
        'dataProvider' => $resultados,
        'columns' => $campos,
                
    ]);?>